/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright (c) Nuvoton Technology Corp. All rights reserved.                                             */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

#include <stdio.h>
#include "NUC1xx.h"
#include "Driver\DrvSYS.h"
#include "Driver\DrvSPI.h"
#include "Driver\DrvUART.h"
#include "Driver\DrvGPIO.h"


void delay(void)
{
    int j;
    for(j=0; j<100000; j++);
}


int main(void)
{
    unsigned int au32SData,data;

    /* Ĵ */
    UNLOCKREG();

    /* 12Mⲿ */
    DrvSYS_SetOscCtrl(E_SYS_XTL12M, 1);

    /* HCLK ʱԴѡⲿ12Mʱź */
    DrvSYS_SelectHCLKSource(0);

    LOCKREG();

    DrvSYS_SetClockDivider(E_SYS_HCLK_DIV, 0); /* HCLK Ƶֵ = 1, HCLK ʱ = 12 MHz*/

    /* ӦGPIOʼΪSPI2ź */
    DrvGPIO_InitFunction(E_FUNC_SPI2);

    /* SPI2Ϊģʽ,źŲΪType1,16-bitλ */
    DrvSPI_Open(eDRVSPI_PORT2, eDRVSPI_MASTER, eDRVSPI_TYPE1, 16);
    
    /* MSB first.SPIݸʽΪMSB  */
    DrvSPI_SetEndian(eDRVSPI_PORT2, eDRVSPI_MSB_FIRST);
    
    /* SS0ΪԶ豸ѡ */
    DrvSPI_EnableAutoSS(eDRVSPI_PORT2, eDRVSPI_SS0);
    
    /* ô豸ѡЧƽΪ͵ƽ */
    DrvSPI_SetSlaveSelectActiveLevel(eDRVSPI_PORT2, eDRVSPI_ACTIVE_LOW_FALLING);

    /* SPI ʱƵΪ 1MHz*/
    DrvSPI_SetClockFreq(eDRVSPI_PORT2, 1000000, 0);

    /* дMMA7455ģʽƼĴ(0x16) */
    au32SData = 0xAC05;     // R/W = 1, Address = 0x16, Data = 0x05
                            // GLVL = 01, 2g is selected for measurement range
                            // MODE = 01, Measurement Mode
                            // SPI3W = 0, SPI is 4 wire mode
    DrvSPI_SingleWrite(eDRVSPI_PORT2, &au32SData);
    while (DrvSPI_IsBusy(eDRVSPI_PORT2));
    
    /* MMA7455ģʽƼĴ(0x16) */
    au32SData = 0x2C00;     // R/W = 0, Address = 0x16
    DrvSPI_SingleWrite(eDRVSPI_PORT2, &au32SData);
    while (DrvSPI_IsBusy(eDRVSPI_PORT2));
    DrvSPI_DumpRxRegister(eDRVSPI_PORT2, &data, 1);
    printf("%d",data);      // ӦΪ 0x05

    while(1){
        /* MMA7455Ĵ0x06, õx8bitsֵ*/
        au32SData = 0x0CFF; // R/W = 0, Address = 0x06
        DrvSPI_SingleWrite(eDRVSPI_PORT2, &au32SData);
        while (DrvSPI_IsBusy(eDRVSPI_PORT2));
        DrvSPI_DumpRxRegister(eDRVSPI_PORT2, &data, 1);
        printf("x: %d\n\r",data);   // ӡXֵ

        delay();

        /* MMA7455Ĵ0x07, õY8bitsֵ */
        au32SData = 0x0EFF; // R/W = 0, Address = 0x07
        DrvSPI_SingleWrite(eDRVSPI_PORT2, &au32SData);
        while (DrvSPI_IsBusy(eDRVSPI_PORT2));
        DrvSPI_DumpRxRegister(eDRVSPI_PORT2, &data, 1);
        printf("y: %d\n\r",data);   // ӡYֵ

        /* MMA7455Ĵ0x07, õZ8bitsֵ */
        au32SData = 0x10FF; // R/W = 0, Address = 0x08
        DrvSPI_SingleWrite(eDRVSPI_PORT2, &au32SData);
        while (DrvSPI_IsBusy(eDRVSPI_PORT2));
        DrvSPI_DumpRxRegister(eDRVSPI_PORT2, &data, 1);
        printf("z: %d\n\r",data);   // ӡZֵ
        delay(); 
        delay();
        delay();
        delay();
        delay();
    };
}

